# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define reltag _beta_5
%define namedreltag -beta-5
%global namedversion %{version}%{?namedreltag}
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           maven-assembly-plugin
Version:        2.2
Release:        4%{?reltag}%{?dist}
Epoch:          0
Summary:        Maven Assembly Plugin
Group:          Development/Java
License:        ASL 2.0
URL:            http://maven.apache.org/plugins/maven-assembly-plugin/
# svn export -r 1171819 http://svn.apache.org/repos/asf/maven/plugins/tags/maven-assembly-plugin-2.2-beta-5 && tar cjf maven-assembly-plugin-2.2-beta-5.tar.bz2 maven-assembly-plugin-2.2-beta-5
Source0:        %{name}-%{namedversion}.tar.bz2
Source1:        maven-assembly-plugin-settings.xml
Source2:        maven-assembly-plugin-jpp-depmap.xml
Obsoletes:      maven2-plugin-assembly <= 0:2.0.8
Provides:       maven2-plugin-assembly = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       maven-archiver >= 0:2.4
Requires:       maven2 >= 0:2.0.4
Requires:       maven-shared-file-management >= 0:1.1
Requires:       maven-common-artifact-filters >= 0:1.1
# XXX: 1.0-beta-2
Requires:       maven-shared-filtering >= 0:1.0
# XXX: 1.0-alpha-2
Requires:       maven-shared-repository-builder >= 0:1.0
Requires:       maven-shared-io >= 0:1.1
# XXX: 1.0-beta-2
Requires:       plexus-active-collections >= 0:1.0
# XXX: 1.0-alpha-12
Requires:       plexus-archiver >= 0:1.0
# XXX: 1.0-alpha-9-stable-1
Requires:       plexus-container-default >= 0:1.0
Requires:       plexus-interpolation >= 0:1.7
# XXX: 2.0.1
Requires:       plexus-utils >= 0:1.5.15
BuildRequires:  easymock-classextension >= 0:1.2
# XXX: 1.0-FCS
BuildRequires:  jaxen >= 0:1.0
BuildRequires:  jdom >= 0:1.0
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  maven-archiver >= 0:2.4
BuildRequires:  maven2 >= 0:2.0.4
BuildRequires:  maven-shared-file-management >= 0:1.1
BuildRequires:  maven-common-artifact-filters >= 0:1.1
# XXX: 1.0-beta-2
BuildRequires:  maven-shared-filtering >= 0:1.0
# XXX: 1.0-alpha-1
BuildRequires:  maven-shared-plugin-testing-tools >= 0:1.0
# XXX: 1.0-alpha-2
BuildRequires:  maven-shared-repository-builder >= 0:1.0
BuildRequires:  maven-shared-io >= 0:1.1
# XXX: 1.0-alpha-1
BuildRequires:  maven-shared-test-tools >= 0:1.0
# XXX: 1.0-beta-2
BuildRequires:  plexus-active-collections >= 0:1.0
# XXX: 1.0-alpha-12
BuildRequires:  plexus-archiver >= 0:1.0
# XXX: 1.0-alpha-9-stable-1
BuildRequires:  plexus-container-default >= 0:1.0
BuildRequires:  plexus-interpolation >= 0:1.7
# XXX: 2.0.1
BuildRequires:  plexus-utils >= 0:1.5.15
# XXX: 1.0-FCS
BuildRequires:  saxpath >= 0:1.0
BuildRequires:  modello-maven-plugin >= 0:1.0
BuildRequires:  plexus-maven-plugin >= 0:1.3.8
BuildRequires:  java-devel
BuildRequires:  jpackage-utils
BuildRequires:  maven2-common-poms
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Assembly Plugin for Maven is primarily intended to allow
users to aggregate the project output along with its
dependencies, modules, site documentation, and other files
into a single distributable archive.

Your project can build distribution "assemblies" easily,
using one of the convenient, prefabricated assembly
descriptors. These descriptors handle many common operations,
such as packaging a project's artifact along with generated
documentation into a single zip archive. Alternatively, your
project can provide its own descriptor and assume a much
higher level of control over how dependencies, modules,
file-sets, and individual files are packaged in the assembly.

Currently it can create distributions in the following formats:
* zip
* tar.gz
* tar.bz2
* jar
* dir
* war
* and any other format that the ArchiveManager
  has been configured for

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%prep
%setup -q -n maven-assembly-plugin-%{namedversion}

mkdir -p target/classes/
cp -pr src/main/resources/META-INF/ target/classes/

perl -pi -e 's|<maven>.*</maven>|<maven>2.0.8</maven>|;' pom.xml

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
export MAVEN_SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.test.failure.ignore \
        install javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
install -Dpm 644 target/maven-assembly-plugin-%{namedversion}.jar %{buildroot}%{_javadir}/maven-assembly-plugin-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} `echo $jar| sed "s|-%{namedversion}||g"`; done)

# poms
install -Dpm 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-maven-assembly-plugin.pom
%add_to_maven_depmap org.apache.maven.plugins maven-assembly-plugin %{namedversion} JPP maven-assembly-plugin

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/maven-assembly-plugin-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/maven-assembly-plugin-%{namedversion}
ln -s maven-assembly-plugin-%{namedversion} %{buildroot}%{_javadocdir}/maven-assembly-plugin

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%{_javadir}*/maven-assembly-plugin-%{namedversion}.jar
%{_javadir}*/maven-assembly-plugin.jar
%{_datadir}/maven2/poms/JPP-maven-assembly-plugin.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/maven-assembly-plugin-%{namedversion}
%{_javadocdir}/maven-assembly-plugin

%changelog
* Fri Jun 29 2012 Ralph Apel <r.apel@r-apel.de> 2.2-4_beta_5
- Switch to (B)R maven-common-artifact-filters

* Sun Jun 17 2012 Ralph Apel <r.apel@r-apel.de> 2.2-3_beta_5
- Avoid FileDigest and PayloadIsXz problems on EL5

* Wed May 23 2012 Ralph Apel <r.apel@r-apel.de> 2.2-2_beta_5
- adapt to current

* Fri Sep 16 2011 David Walluck <dwalluck@redhat.com> 2.2-1_beta_5
- fix for JPackage

* Tue Sep 28 2010 Hui Wang <huwnag@redhat.com> - 2.2-0.7.beta5
- Adjust BRs

* Thu Sep 02 2010 Hui Wang <huwnag@redhat.com> - 2.2-0.6.beta5
- Rebuild with maven221
- Enable javadoc

* Sun Jul 25 2010 Hui Wang <huwang@redhat.com> - 2.2-0.5.beta5
- Fix mavenpomdir
- Add easymockclassextension and qdox jpp depmap

* Tue Jun 15 2010 Alexander Kurtakov <akurtako@redhat.com> 2.2-0.4.beta5
- Add missing BuildRequires.

* Tue Jun 15 2010 Alexander Kurtakov <akurtako@redhat.com> 2.2-0.3.beta5
- Add missing Requires.

* Thu Jun 03 2010 Yong Yang <yyang@redhat.com> - 2.2-0.2.beta5
- Chmod 0644 for depmap.xml
- Fix Obsoletes and Provides
- Change to BR java

* Thu May 20 2010 Yong Yang <yyang@redhat.com> - 2.2-0.1.beta5
- Initial build
